% FEEC/Unicamp
% 28/05/2017
% Verification of each neuron's response when compared to the desired output
% Use of weights obtained after training
clear all;
close all;
fig = 1;
load vw;
load vv;
load vc;
load vbias;
%load data;
opt = input('Function that was approximated: ');
[X,S,v1,v2] = datatest(opt);
[m,n] = size(v);
[N,r] = size(S);
P = length(c(1,:));
disp(' Number of test patterns');
disp(N);
disp('Number of hidden nodes');
disp(n);
disp('Order of Hermite polynomials');
disp(P);
Srn = zeros(N,r);
for j=1:n,
	Srn = Srn + factiv(X*v(:,j),c(j,:))*w(j,:);
	for k=1:r,
		Srn(:,k) = Srn(:,k)+bias(j,k);
	end
end
%disp('S');disp(S);
%disp('Srn');disp(Srn);
disp('m_norm(S-Srn)');disp(m_norm(S-Srn));
for k=1:r,
    figure(fig);fig = fig+1;subplot(111);
	plot(S(:,k),'w');hold on;plot(Srn(:,k),'g');hold off;
	title('Des (w) NN (g)');% pause;
end
if opt>=2 & opt<=7,
	l = 1;
	for k=1:sqrt(N),
		for j=1:sqrt(N),
			y(j,k) = S(l,1);
			yrn(j,k) = Srn(l,1);
			l = l+1;
		end
    end
    figure(fig);fig = fig+1;subplot(111);
	if opt == 2,
		mesh(1-v1,v2,y);
		xlabel('1-x1');
	else
		mesh(v1,v2,y);
		xlabel('x1');
	end
	ylabel('x2');
	zlabel('G(x1,x2)');
	title('Original Mapping (to be approximated)');% pause;
    figure(fig);fig = fig+1;subplot(111);
	if opt == 2,
		mesh(1-v1,v2,yrn);
		xlabel('1-x1');
	else
		mesh(v1,v2,yrn);
		xlabel('x1');
    end
    ylabel('x2');
	zlabel('NN(x1,x2)');
	title('NN approximation');% pause;
    figure(fig);fig = fig+1;subplot(111);
	if opt == 2,
		mesh(1-v1,v2,y-yrn);
		xlabel('1-x1');
	else
		mesh(v1,v2,y-yrn);
		xlabel('x1');
	end
	ylabel('x2');
	zlabel('G(x1,x2)-NN(x1,x2)');
	title('Approximation error');% pause;
end
nptos = 50;
for j=1:n,
	minz = min(X*v(:,j));
	maxz = max(X*v(:,j));
	passo = (maxz-minz)/nptos;
	i = 1;
	for z=minz:passo:maxz,
		x(i) = z;
		yy(i,1) = factiv(z,c(j,:));
		i = i+1;
    end
    figure(fig);fig = fig+1;subplot(111);
	plot(x,yy);title(sprintf('Activation function %d',j));% pause;
end
are = 0;
for l=1:N,
	are = are + norm(S(l,:)-Srn(l,:))/norm(S(l,:));
end
are = are/N;
disp('Average relative error');disp(are);
for k=1:r,
	Smedio(1,k) = (1/N)*S(:,k)'*ones(N,1);
end
den = 0;
num = 0;
for l=1:N,
	for k=1:r,
		num = num+(S(l,k)-Srn(l,k))^2;
		den = den+(S(l,k)-Smedio(1,k))^2;
	end
end
fvu = num/den;
disp('Fraction of Variance Unexplained');disp(fvu);
