% FEEC/Unicamp
% 28/05/2017
% Auxiliary functions
% factiv.m / dfactiv.m / ddfactiv.m / dfobj.m / negating.m
%
function [vcalc] = calcv(v,c,u,X)
m = length(v);
f = factiv(X*v,c);
df = dfactiv(X*v,c);
ddf = ddfactiv(X*v,c);
[dF,ddF] = dfobj(f,df,ddf,u,X);
F = (f'*u)^2/(f'*f);
F1 = 0.5*F; % F1 initially receives any value less than F
threshold4 = 5.0e-4;
threshold5 = 1.0e-9;
while norm(dF,2) > threshold4,
	alpha = 1;
	[ddF,det] = negating(ddF); % If det=1, then ddF was made negative definite
	while F1 <= F,
		v1 = v-alpha*(ddF\dF);
		f1 = factiv(X*v1,c);
		F1 = (f1'*u)^2/(f1'*f1);
		if alpha < threshold5,
			disp('Problem in 2nd order approximation. Trying 1st. order...');
			alpha = 1;
			F1 = 0.5*F;
			while F1 <= F,
				v1 = v+alpha*dF;
				f1 = factiv(X*v1,c);
				F1 = (f1'*u)^2/(f1'*f1);
				if alpha < threshold5,
					disp(sprintf('alpha=%g/norm(dF)=%g/threshold4=%g/F1=%g/F=%g',alpha,norm(dF,2),threshold4,F1,F));
					error('Problems in the optimization algorithm (calcv.m)');
				end
				alpha = 0.5*alpha;
			end
		end
		alpha = 0.5*alpha;
	end
	v = v1;f = f1;F = F1;
	df = dfactiv(X*v,c);
	ddf = ddfactiv(X*v,c);
	[dF,ddF] = dfobj(f,df,ddf,u,X);
end
vcalc = v;
